from PyQt5 import QtCore, QtWidgets, QtGui
from PyQt5.QtWidgets import  QWidget, QLabel, QVBoxLayout, QMainWindow, QMessageBox
from collections import OrderedDict
import sqlite3
import sys

conn = sqlite3.connect('mylist.db')

c = conn.cursor()

c.execute("""CREATE TABLE if not exists well_list(
    list_item text)
    """)
    
conn.commit()

conn.close()

class OutputWindow(QMainWindow):
    def __init__(self, output_values):
        super().__init__()
        self.setWindowTitle('Calculated Outputs')
        self.setGeometry(200, 200, 500, 500)

        # Create a central widget and layout
        self.central_widget = QWidget()
        self.central_layout = QVBoxLayout(self.central_widget)

        # Create labels to display the output values
        for label, value in output_values.items():
            output_label = QLabel("{}: {}".format(label, value))
            self.central_layout.addWidget(output_label)

        self.setCentralWidget(self.central_widget)
        self.adjustSize()
        
        
        
class Ui_Software(object):
    def setupUi(self, Software):
        Software.setObjectName("Software")
        Software.resize(1000, 655)
        Software.setMinimumSize(QtCore.QSize(1000, 500))
        self.centralwidget = QtWidgets.QWidget(Software)
        self.centralwidget.setObjectName("centralwidget")
        self.tabWidget = QtWidgets.QTabWidget(self.centralwidget)
        self.tabWidget.setGeometry(QtCore.QRect(0, 0, 991, 601))
        self.tabWidget.setTabPosition(QtWidgets.QTabWidget.North)
        self.tabWidget.setMovable(True)
        self.tabWidget.setObjectName("tabWidget")
        self.tab_3 = QtWidgets.QWidget()
        self.tab_3.setObjectName("tab_3")
        self.SaveButton = QtWidgets.QPushButton(self.tab_3)
        self.SaveButton.setGeometry(QtCore.QRect(470, 520, 151, 31))
        self.SaveButton.setObjectName("SaveButton")
        self.layoutWidget = QtWidgets.QWidget(self.tab_3)
        self.layoutWidget.setGeometry(QtCore.QRect(300, 60, 2, 2))
        self.layoutWidget.setObjectName("layoutWidget")
        self.horizontalLayout = QtWidgets.QHBoxLayout(self.layoutWidget)
        self.horizontalLayout.setContentsMargins(0, 0, 0, 0)
        self.horizontalLayout.setObjectName("horizontalLayout")
        self.layoutWidget1 = QtWidgets.QWidget(self.tab_3)
        self.layoutWidget1.setGeometry(QtCore.QRect(80, 20, 851, 470))
        self.layoutWidget1.setObjectName("layoutWidget1")
        self.verticalLayout = QtWidgets.QVBoxLayout(self.layoutWidget1)
        self.verticalLayout.setContentsMargins(0, 0, 0, 0)
        self.verticalLayout.setObjectName("verticalLayout")
        self.frame_3 = QtWidgets.QFrame(self.layoutWidget1)
        self.frame_3.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frame_3.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frame_3.setObjectName("frame_3")
        self.horizontalLayout_2 = QtWidgets.QHBoxLayout(self.frame_3)
        self.horizontalLayout_2.setObjectName("horizontalLayout_2")
        self.label = QtWidgets.QLabel(self.frame_3)
        self.label.setMinimumSize(QtCore.QSize(100, 0))
        self.label.setMaximumSize(QtCore.QSize(100, 16777215))
        self.label.setObjectName("label")
        self.horizontalLayout_2.addWidget(self.label)
        self.Nameline = QtWidgets.QLineEdit(self.frame_3)
        self.Nameline.setMinimumSize(QtCore.QSize(220, 25))
        self.Nameline.setMaximumSize(QtCore.QSize(220, 16777215))
        self.Nameline.setObjectName("Nameline")
        self.horizontalLayout_2.addWidget(self.Nameline)
        self.Typeline = QtWidgets.QLineEdit(self.frame_3)
        self.Typeline.setMinimumSize(QtCore.QSize(220, 25))
        self.Typeline.setMaximumSize(QtCore.QSize(220, 16777215))
        self.Typeline.setObjectName("Typeline")
        self.horizontalLayout_2.addWidget(self.Typeline)
        self.Resline = QtWidgets.QLineEdit(self.frame_3)
        self.Resline.setMinimumSize(QtCore.QSize(220, 25))
        self.Resline.setMaximumSize(QtCore.QSize(220, 16777215))
        self.Resline.setObjectName("Resline")
        self.horizontalLayout_2.addWidget(self.Resline)
        spacerItem = QtWidgets.QSpacerItem(40, 20, QtWidgets.QSizePolicy.Expanding, QtWidgets.QSizePolicy.Minimum)
        self.horizontalLayout_2.addItem(spacerItem)
        self.verticalLayout.addWidget(self.frame_3)
        self.frame_4 = QtWidgets.QFrame(self.layoutWidget1)
        self.frame_4.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frame_4.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frame_4.setObjectName("frame_4")
        self.gridLayout_4 = QtWidgets.QGridLayout(self.frame_4)
        self.gridLayout_4.setObjectName("gridLayout_4")
        self.label_2 = QtWidgets.QLabel(self.frame_4)
        self.label_2.setMinimumSize(QtCore.QSize(200, 0))
        self.label_2.setMaximumSize(QtCore.QSize(200, 16777215))
        self.label_2.setObjectName("label_2")
        self.gridLayout_4.addWidget(self.label_2, 0, 0, 1, 1)
        self.Sumtext = QtWidgets.QTextEdit(self.frame_4)
        self.Sumtext.setMinimumSize(QtCore.QSize(500, 100))
        self.Sumtext.setMaximumSize(QtCore.QSize(500, 100))
        self.Sumtext.setObjectName("Sumtext")
        self.gridLayout_4.addWidget(self.Sumtext, 1, 1, 1, 1)
        self.label_3 = QtWidgets.QLabel(self.frame_4)
        self.label_3.setMaximumSize(QtCore.QSize(200, 16777215))
        self.label_3.setObjectName("label_3")
        self.gridLayout_4.addWidget(self.label_3, 1, 0, 1, 1)
        self.Objtext = QtWidgets.QTextEdit(self.frame_4)
        self.Objtext.setMinimumSize(QtCore.QSize(500, 100))
        self.Objtext.setMaximumSize(QtCore.QSize(500, 100))
        self.Objtext.setObjectName("Objtext")
        self.gridLayout_4.addWidget(self.Objtext, 0, 1, 1, 1)
        spacerItem1 = QtWidgets.QSpacerItem(40, 20, QtWidgets.QSizePolicy.Expanding, QtWidgets.QSizePolicy.Minimum)
        self.gridLayout_4.addItem(spacerItem1, 0, 2, 1, 1)
        spacerItem2 = QtWidgets.QSpacerItem(40, 20, QtWidgets.QSizePolicy.Expanding, QtWidgets.QSizePolicy.Minimum)
        self.gridLayout_4.addItem(spacerItem2, 1, 2, 1, 1)
        self.verticalLayout.addWidget(self.frame_4)
        self.tabWidget.addTab(self.tab_3, "")
        self.tab = QtWidgets.QWidget()
        self.tab.setObjectName("tab")
        self.frame = QtWidgets.QFrame(self.tab)
        self.frame.setGeometry(QtCore.QRect(10, 10, 891, 191))
        self.frame.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frame.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frame.setObjectName("frame")
        self.gridLayout = QtWidgets.QGridLayout(self.frame)
        self.gridLayout.setObjectName("gridLayout")
        self.DisciplineLabel = QtWidgets.QLabel(self.frame)
        self.DisciplineLabel.setObjectName("DisciplineLabel")
        self.gridLayout.addWidget(self.DisciplineLabel, 0, 0, 1, 1)
        self.DisciplineBox = QtWidgets.QComboBox(self.frame)
        self.DisciplineBox.setObjectName("DisciplineBox")
        self.DisciplineBox.addItem("Plug and Abandonment")
        self.DisciplineBox.setItemText(1, "")
        self.gridLayout.addWidget(self.DisciplineBox, 0, 1, 1, 1)
        self.EventLabel = QtWidgets.QLabel(self.frame)
        self.EventLabel.setObjectName("EventLabel")
        self.gridLayout.addWidget(self.EventLabel, 1, 2, 1, 1)
        self.ObjectiveLabel = QtWidgets.QLabel(self.frame)
        self.ObjectiveLabel.setObjectName("ObjectiveLabel")
        self.gridLayout.addWidget(self.ObjectiveLabel, 1, 0, 1, 1)
        self.ObjectiveBox = QtWidgets.QComboBox(self.frame)
        self.ObjectiveBox.setObjectName("ObjectiveBox")
        self.ObjectiveBox.addItem("Choose an option...")
        self.ObjectiveBox.addItem("Cementing",["Cement Plug","Cementing","Circ/Cond","Loss","MU,LD","Other","Prepare","RU,RD","Test","Trip"])
        self.ObjectiveBox.addItem("Cementing_int",["BOP", "Guide Posts","Bullhead","Cement","Clean hub", "DHSV - Brush Valve","DHSV - Insert Valve","Drift Well", "Manipulate Comp. eq.","Flowback","Injection Test","Logging CH", "LPR", "Lubticator Section","LS/SSTT","Mechanical Plug","Mob/Demob Vessel","Mob/Demobe/Spot","Move","Other","Scraper Run","Rig Over","Rig Up/Down","Rig/general","Survey","Tbg Hng/XT Plug","Template hatches","Tree Cap","Tree Debris Cap/THISL","Well Control","X-mas Tree"])
        self.ObjectiveBox.addItem("Cement Plug",["Balanced Plug","Pump and Pull","Two-Plug Method","Dump Bailer"])
        self.ObjectiveBox.addItem("Pumping",["Inject_Bullhead","Circulate","Displace","Flow Rate","Other","TBT","Safety Meeting","General Investigation","Permit To Work","No Activity","Waiting, other","Safety Related","ROV Operations","Site survey","Manipulate Compl. eq.","Repair or Replace","Tbg Hng/XT Plug","X-mas Tree"])
        self.ObjectiveBox.addItem("Logging_DP",["BOP","MU BHA","BO BHA", "RIH","POOH","Manipulate Compl. eq.","Flowback","Injection test","Logging CH","LRP","Lubricator section","LS/SSTT","Mechanical Plug","Mob/Demob Vessel","Mob/Demob/Spot","Other"])
        self.ObjectiveBox.addItem("Section Milling",["Swarf Handling","Well control","Well Design","Casing Configuration","Milling fluid selection","Cut-out / Window in casing","Milling BHA configuration","Set Cement plug","Clean runs/ BOP cleaning","Set Mechanical plug","Section mill 165 ft (50m) of 9 5/8","Underream Open Hole"])
        self.ObjectiveBox.addItem("Plug_int",["Rigging_plug","Mechanical_Plug","Junk_basket","Well_Control_int","Scraper_cleanup_run","Rig_over","Mob_demob","Other_plug_int"])
        self.ObjectiveBox.addItem("Logging",["BOP","Guide Posts","Bullhead","Clean hub","DHSV - Brush valve","DHSV - Insert valve","Drift well","Manipulate Compl. eq.","Flowback","Injection test","Logging CH","LRP","Lubricator section","LS/SSTT","Mechanical Plug","Mob/Demob Vessel","Mob/Demob/Spot","Move","Other","Scraper Run","Rig Over","Rig Up/Down","Rig/general","Survey","Tbg Hng/XT Plug","Template hatches","Tree Cap","Tree Debris Cap/THISL","Well Control","X-mas Tree"])
        self.ObjectiveBox.addItem("Casing",["MU_LD_Hanger","MU_Shoetrack","Run_casing_Liner_joints","Run_casing_Liner_stands","Run_casing_Liner_Flowcheck","Run_casing_Liner_circ_condition", "Run_casing_Liner_Handling equipment","Run_casing_Liner_Wash_work","Run_casing_Liner_Other"])
        self.ObjectiveBox.addItem("Liner",["RU liner equipment", "MU Shoe", "Run liner", "Run liner, Circ", "Run liner, wash/work", "Change handling equipment", "Change handling equipment/MU Hanger", "Run liner on landing string", "Run liner on landing string, wash/work", "Circulation/prep. time setting hanger/packer", "Gravel pack liner/liner", "PU RT", "LD RT"])
        self.ObjectiveBox.addItem("Drift Well",["Drift_run", "Mob_demob", "Rig_over", "Well_Control_int", "Pumping", "Rigging_Drift_run_int"])
        self.ObjectiveBox.addItem("Fishing DP",["R/U, R/D", "M/U, L/D", "RIH/POOH", "Trip", "Fishing", "Stuck/Lost Circ", "Other", "Well control", "Cut Casing/liner/tieback", "Mill Casing/liner/tieback", "Release fish incl. Casing/liner/tieback", "Other"])
        self.ObjectiveBox.addItem("Fishing_int",["BOP", "Guide Posts", "Bullhead", "Clean hub", "Cutting", "DHSV - Brush valve", "DHSV - Insert valve", "Drift well", "Manipulate Compl. eq.", "Fishing", "Flowback", "Junk basket", "LRP", "Lubricator section", "LS/SSTT", "Mechanical Plug", "Milling", "Mob/Demob Vessel", "Mob/Demob/Spot", "Move", "Other", "Scraper Run", "Rig Over", "Rig Up/Down", "Rig/general", "Survey", "Tbg Hng/XT Plug", "Template hatches", "Tree Cap", "Tree Debris Cap/THISL", "Well Control", "X-mas Tree"])
        self.ObjectiveBox.addItem("Suspension",["BOP's etc - Install/Remove", "BPV - TH Plug", "Braided Line Operations", "Bridge Plug - Install via DP/Tubing", "Cement Squeeze", "Cement Stinger RIH/POOH", "Cut & Retrieve Casing / Install Suspension Equipment", "Drill / Mill Cement", "Drill String - RIH / POOH", "Electric Line Operations", "General Investigation", "Hydraulic Workover Operations", "Inflow Test", "Maintain/Change Out Drillstring", "Maintenance - Rig", "Manipulate Downhole Equipment", "Mill / Cut / Push", "Moving / Skidding Rig / Work unit", "No Activity", "Permit To Work", "Preparation / Clearing Site", "Pressure Test", "Production Riser - Install/Remove", "Pump / Circulate / Displace", "Repair or Replace ROV", "Retrievable Packer - Install and Remove via DP/Tubing", "Rig Up/Down", "ROV Operations", "Safety Related", "Scraper Run", "Seabed Survey SCP", "Set Cement Plug", "Slick Line Operations", "String - Works / Jar / Free Stuck Equipment", "Suspension Flange - Install/Remove", "Tie-Back String -Install/Retrieve", "Waiting on Cement", "Well Control (Losses)", "Well Control (Pressure)", "Wellhead maintenance"])
        self.ObjectiveBox.addItem("Suspension_intv",["BOP", "BPV - TH Plug", "Lubricator section", "LS/SSTT", "Mechanical Plug", "Mob/Demob Vessel", "Mob/Demob/Spot", "Move", "Other", "Inflow Test", "Scraper Run", "Rig Over", "Rig Up/Down", "Rig/general", "Survey", "Tbg Hng/XT Plug", "Template hatches", "Tree Cap", "Tree Debris Cap/THISL", "Well Control", "X-mas Tree", "General Investigation", "Maintenance - Rig", "Install Suspension Equipment", "Manipulate Downhole Equipment", "No Activity", "Permit To Work", "Preparation / Clearing Site", "Pressure Test", "Production Riser - Install/Remove", "Repair or Replace ROV", "ROV Operations", "Safety Related", "Seabed Survey SCP", "Suspension Flange - Install/Remove", "Well Control (Losses)", "Well Control (Pressure)", "Wellhead maintenance", "Guide Posts", "Bullhead", "Clean hub", "DHSV - Brush valve", "DHSV - Insert valve", "Drift well", "Manipulate Compl. eq.", "Flowback", "Junk basket", "LRP", "Transit", "Transponder", "Tubeclean", "Umbilical", "Waste Injection"])
        self.ObjectiveBox.addItem("Well Control",["Observation", "Circulate", "Flowcheck", "Kill well", "Cement plug", "Stuck/Lost Circ"])
        
        #Click The Objective
        
        self.ObjectiveBox.activated.connect(self.clicker)
        self.SaveButton.pressed.connect(self.save_it)
        
        self.gridLayout.addWidget(self.ObjectiveBox, 1, 1, 1, 1)
        self.SectionBox = QtWidgets.QComboBox(self.frame)
        self.SectionBox.setObjectName("SectionBox")
        self.SectionBox.addItem("Deep Plugging")
        self.SectionBox.addItem("Middle/Secondary Plugging")
        self.SectionBox.addItem("Shalow Plugging")
        self.gridLayout.addWidget(self.SectionBox, 0, 3, 1, 1)
        self.EventBox = QtWidgets.QComboBox(self.frame)
        self.EventBox.setObjectName("EventBox")
        self.gridLayout.addWidget(self.EventBox, 1, 3, 1, 1)
        self.SectionLabel = QtWidgets.QLabel(self.frame)
        self.SectionLabel.setObjectName("SectionLabel")
        self.gridLayout.addWidget(self.SectionLabel, 0, 2, 1, 1)
        self.frame_2 = QtWidgets.QFrame(self.tab)
        self.frame_2.setGeometry(QtCore.QRect(0, 240, 901, 101))
        self.frame_2.setFocusPolicy(QtCore.Qt.NoFocus)
        self.frame_2.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frame_2.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frame_2.setObjectName("frame_2")
        self.gridLayout_2 = QtWidgets.QGridLayout(self.frame_2)
        self.gridLayout_2.setObjectName("gridLayout_2")
        self.EngBox1 = QtWidgets.QComboBox(self.frame_2)
        self.EngBox1.setObjectName("EngBox1")
        self.EngBox1.addItem("NA")
        self.EngBox1.addItem("T&D")
        self.EngBox1.addItem("Hydeaulic")
        self.EngBox1.addItem("Bit")
        self.EngBox1.addItem("ECD")
        self.EngBox1.addItem("Pump Design")
        self.EngBox1.addItem("Kill Well")
        self.EngBox1.addItem("Kick Tolerance")
        self.EngBox1.addItem("Casing Design")
        self.EngBox1.addItem("Tubing Design")
        self.EngBox1.addItem("Casing Wear")
        self.EngBox1.addItem("Milling")
        self.EngBox1.addItem("Cement Plugging")
        self.gridLayout_2.addWidget(self.EngBox1, 0, 1, 1, 1)
        self.label_9 = QtWidgets.QLabel(self.frame_2)
        self.label_9.setObjectName("label_9")
        self.gridLayout_2.addWidget(self.label_9, 0, 2, 1, 1)
        self.label_7 = QtWidgets.QLabel(self.frame_2)
        self.label_7.setObjectName("label_7")
        self.gridLayout_2.addWidget(self.label_7, 0, 0, 1, 1)
        self.ContBox1 = QtWidgets.QComboBox(self.frame_2)
        self.ContBox1.setObjectName("ContBox1")
        self.ContBox1.addItem("Bits")
        self.ContBox1.addItem("Casing Accessories")
        self.ContBox1.addItem("Casing running")
        self.ContBox1.addItem("Cementing Services")
        self.ContBox1.addItem("Completion tubing")
        self.ContBox1.addItem("Coring")
        self.ContBox1.addItem("Coiled Tubing (CT)")
        self.ContBox1.addItem("D&I services and tools")
        self.ContBox1.addItem("Fishing & milling")
        self.ContBox1.addItem("Environmental & Waste control")
        self.ContBox1.addItem("Gyro Surveying")
        self.ContBox1.addItem("Inspection Services")
        self.ContBox1.addItem("Mud chemicals")
        self.ContBox1.addItem("Mud logging")
        self.ContBox1.addItem("Rig contract")
        self.ContBox1.addItem("Well testing services")
        self.ContBox1.addItem("WH /XT")
        self.gridLayout_2.addWidget(self.ContBox1, 0, 3, 1, 1)
        self.ContBox2 = QtWidgets.QComboBox(self.frame_2)
        self.ContBox2.addItem("Bits")
        self.ContBox2.addItem("Casing Accessories")
        self.ContBox2.addItem("Casing running")
        self.ContBox2.addItem("Cementing Services")
        self.ContBox2.addItem("Completion tubing")
        self.ContBox2.addItem("Coring")
        self.ContBox2.addItem("Coiled Tubing (CT)")
        self.ContBox2.addItem("D&I services and tools")
        self.ContBox2.addItem("Fishing & milling")
        self.ContBox2.addItem("Environmental & Waste control")
        self.ContBox2.addItem("Gyro Surveying")
        self.ContBox2.addItem("Inspection Services")
        self.ContBox2.addItem("Mud chemicals")
        self.ContBox2.addItem("Mud logging")
        self.ContBox2.addItem("Rig contract")
        self.ContBox2.addItem("Well testing services")
        self.ContBox2.addItem("WH /XT")
        self.ContBox2.setObjectName("ContBox2")
        self.gridLayout_2.addWidget(self.ContBox2, 1, 3, 1, 1)
        self.EngBox2 = QtWidgets.QComboBox(self.frame_2)
        self.EngBox2.setObjectName("EngBox2")
        self.EngBox2.addItem("NA")
        self.EngBox2.addItem("T&D")
        self.EngBox2.addItem("Hydeaulic")
        self.EngBox2.addItem("Bit")
        self.EngBox2.addItem("ECD")
        self.EngBox2.addItem("Pump Design")
        self.EngBox2.addItem("Kill Well")
        self.EngBox2.addItem("Kick Tolerance")
        self.EngBox2.addItem("Casing Design")
        self.EngBox2.addItem("Tubing Design")
        self.EngBox2.addItem("Casing Wear")
        self.EngBox2.addItem("Milling")
        self.EngBox2.addItem("Cement Plugging")
        self.gridLayout_2.addWidget(self.EngBox2, 1, 1, 1, 1)
        self.tabWidget.addTab(self.tab, "")
        self.tab_2 = QtWidgets.QWidget()
        self.tab_2.setObjectName("tab_2")
        self.CPTab = QtWidgets.QTabWidget(self.tab_2)
        self.CPTab.setGeometry(QtCore.QRect(0, 0, 981, 571))
        self.CPTab.setLayoutDirection(QtCore.Qt.LeftToRight)
        self.CPTab.setTabPosition(QtWidgets.QTabWidget.North)
        self.CPTab.setObjectName("CPTab")
        self.CP1Tab = QtWidgets.QWidget()
        self.CP1Tab.setObjectName("CP1Tab")
        self.Info_Label = QtWidgets.QLabel(self.CP1Tab)
        self.Info_Label.setGeometry(QtCore.QRect(10, 0, 951, 541))
        self.Info_Label.setScaledContents(True)
        self.Info_Label.setWordWrap(True)
        self.Info_Label.setObjectName("Info_Label")
        self.CPTab.addTab(self.CP1Tab, "")
        self.CP2Tab = QtWidgets.QWidget()
        self.CP2Tab.setObjectName("CP2Tab")
        self.gridLayout_8 = QtWidgets.QGridLayout(self.CP2Tab)
        self.gridLayout_8.setObjectName("gridLayout_8")
        self.InputFrame = QtWidgets.QFrame(self.CP2Tab)
        self.InputFrame.setAccessibleName("")
        self.InputFrame.setStyleSheet("")
        self.InputFrame.setFrameShape(QtWidgets.QFrame.NoFrame)
        self.InputFrame.setFrameShadow(QtWidgets.QFrame.Raised)
        self.InputFrame.setObjectName("InputFrame")
        self.label_4 = QtWidgets.QLabel(self.InputFrame)
        self.label_4.setGeometry(QtCore.QRect(-10, -10, 981, 561))
        self.label_4.setText("")
        self.label_4.setPixmap(QtGui.QPixmap("IMG.jpg"))
        self.label_4.setScaledContents(True)
        self.label_4.setObjectName("label_4")
        self.layoutWidget_2 = QtWidgets.QWidget(self.InputFrame)
        self.layoutWidget_2.setGeometry(QtCore.QRect(90, 190, 257, 84))
        self.layoutWidget_2.setObjectName("layoutWidget_2")
        self.gridLayout_9 = QtWidgets.QGridLayout(self.layoutWidget_2)
        self.gridLayout_9.setContentsMargins(0, 0, 0, 0)
        self.gridLayout_9.setObjectName("gridLayout_9")
        self.CasingSizeLabel = QtWidgets.QLabel(self.layoutWidget_2)
        self.CasingSizeLabel.setMinimumSize(QtCore.QSize(100, 0))
        self.CasingSizeLabel.setMaximumSize(QtCore.QSize(150, 16777215))
        self.CasingSizeLabel.setLayoutDirection(QtCore.Qt.LeftToRight)
        self.CasingSizeLabel.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.CasingSizeLabel.setObjectName("CasingSizeLabel")
        self.gridLayout_9.addWidget(self.CasingSizeLabel, 0, 0, 1, 1)
        self.CSLineEdit = QtWidgets.QLineEdit(self.layoutWidget_2)
        self.CSLineEdit.setMinimumSize(QtCore.QSize(100, 0))
        self.CSLineEdit.setMaximumSize(QtCore.QSize(100, 16777215))
        self.CSLineEdit.setLayoutDirection(QtCore.Qt.LeftToRight)
        self.CSLineEdit.setAutoFillBackground(False)
        self.CSLineEdit.setText("")
        self.CSLineEdit.setClearButtonEnabled(True)
        self.CSLineEdit.setObjectName("CSLineEdit")
        self.gridLayout_9.addWidget(self.CSLineEdit, 0, 1, 1, 1)
        self.gridLayout_3 = QtWidgets.QGridLayout()
        self.gridLayout_3.setObjectName("gridLayout_3")
        self.CasingShoeTVDLabel = QtWidgets.QLabel(self.layoutWidget_2)
        self.CasingShoeTVDLabel.setMinimumSize(QtCore.QSize(100, 0))
        self.CasingShoeTVDLabel.setMaximumSize(QtCore.QSize(150, 16777215))
        self.CasingShoeTVDLabel.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.CasingShoeTVDLabel.setObjectName("CasingShoeTVDLabel")
        self.gridLayout_3.addWidget(self.CasingShoeTVDLabel, 0, 0, 1, 1)
        self.CasingShoeTVDEditLine = QtWidgets.QLineEdit(self.layoutWidget_2)
        self.CasingShoeTVDEditLine.setMinimumSize(QtCore.QSize(100, 0))
        self.CasingShoeTVDEditLine.setMaximumSize(QtCore.QSize(100, 100))
        self.CasingShoeTVDEditLine.setLayoutDirection(QtCore.Qt.LeftToRight)
        self.CasingShoeTVDEditLine.setAutoFillBackground(False)
        self.CasingShoeTVDEditLine.setText("")
        self.CasingShoeTVDEditLine.setClearButtonEnabled(True)
        self.CasingShoeTVDEditLine.setObjectName("CasingShoeTVDEditLine")
        self.gridLayout_3.addWidget(self.CasingShoeTVDEditLine, 0, 1, 1, 1)
        self.CasingShoeMDLabel = QtWidgets.QLabel(self.layoutWidget_2)
        self.CasingShoeMDLabel.setMinimumSize(QtCore.QSize(100, 0))
        self.CasingShoeMDLabel.setMaximumSize(QtCore.QSize(150, 16777215))
        self.CasingShoeMDLabel.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.CasingShoeMDLabel.setObjectName("CasingShoeMDLabel")
        self.gridLayout_3.addWidget(self.CasingShoeMDLabel, 1, 0, 1, 1)
        self.CasingShoeMDLineEdit = QtWidgets.QLineEdit(self.layoutWidget_2)
        self.CasingShoeMDLineEdit.setMinimumSize(QtCore.QSize(100, 0))
        self.CasingShoeMDLineEdit.setMaximumSize(QtCore.QSize(100, 100))
        self.CasingShoeMDLineEdit.setLayoutDirection(QtCore.Qt.LeftToRight)
        self.CasingShoeMDLineEdit.setAutoFillBackground(False)
        self.CasingShoeMDLineEdit.setText("")
        self.CasingShoeMDLineEdit.setClearButtonEnabled(True)
        self.CasingShoeMDLineEdit.setObjectName("CasingShoeMDLineEdit")
        self.gridLayout_3.addWidget(self.CasingShoeMDLineEdit, 1, 1, 1, 1)
        self.gridLayout_9.addLayout(self.gridLayout_3, 1, 0, 1, 2)
        self.layoutWidget_3 = QtWidgets.QWidget(self.InputFrame)
        self.layoutWidget_3.setGeometry(QtCore.QRect(120, 450, 246, 53))
        self.layoutWidget_3.setObjectName("layoutWidget_3")
        self.gridLayout_10 = QtWidgets.QGridLayout(self.layoutWidget_3)
        self.gridLayout_10.setContentsMargins(0, 0, 0, 0)
        self.gridLayout_10.setObjectName("gridLayout_10")
        self.HoleDepthMDLabel = QtWidgets.QLabel(self.layoutWidget_3)
        self.HoleDepthMDLabel.setMinimumSize(QtCore.QSize(100, 0))
        self.HoleDepthMDLabel.setMaximumSize(QtCore.QSize(150, 16777215))
        self.HoleDepthMDLabel.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.HoleDepthMDLabel.setObjectName("HoleDepthMDLabel")
        self.gridLayout_10.addWidget(self.HoleDepthMDLabel, 0, 0, 1, 1)
        self.HDMDLineEdit = QtWidgets.QLineEdit(self.layoutWidget_3)
        self.HDMDLineEdit.setMinimumSize(QtCore.QSize(100, 0))
        self.HDMDLineEdit.setMaximumSize(QtCore.QSize(100, 16777215))
        self.HDMDLineEdit.setLayoutDirection(QtCore.Qt.LeftToRight)
        self.HDMDLineEdit.setAutoFillBackground(False)
        self.HDMDLineEdit.setText("")
        self.HDMDLineEdit.setClearButtonEnabled(True)
        self.HDMDLineEdit.setObjectName("HDMDLineEdit")
        self.gridLayout_10.addWidget(self.HDMDLineEdit, 0, 1, 1, 1)
        self.HoleDepthTVDLabel = QtWidgets.QLabel(self.layoutWidget_3)
        self.HoleDepthTVDLabel.setMinimumSize(QtCore.QSize(100, 0))
        self.HoleDepthTVDLabel.setMaximumSize(QtCore.QSize(150, 16777215))
        self.HoleDepthTVDLabel.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.HoleDepthTVDLabel.setObjectName("HoleDepthTVDLabel")
        self.gridLayout_10.addWidget(self.HoleDepthTVDLabel, 1, 0, 1, 1)
        self.HDTVDLineEdit = QtWidgets.QLineEdit(self.layoutWidget_3)
        self.HDTVDLineEdit.setMinimumSize(QtCore.QSize(100, 0))
        self.HDTVDLineEdit.setMaximumSize(QtCore.QSize(100, 16777215))
        self.HDTVDLineEdit.setLayoutDirection(QtCore.Qt.LeftToRight)
        self.HDTVDLineEdit.setAutoFillBackground(False)
        self.HDTVDLineEdit.setText("")
        self.HDTVDLineEdit.setClearButtonEnabled(True)
        self.HDTVDLineEdit.setObjectName("HDTVDLineEdit")
        self.gridLayout_10.addWidget(self.HDTVDLineEdit, 1, 1, 1, 1)
        self.layoutWidget_5 = QtWidgets.QWidget(self.InputFrame)
        self.layoutWidget_5.setGeometry(QtCore.QRect(610, 380, 261, 47))
        self.layoutWidget_5.setObjectName("layoutWidget_5")
        self.gridLayout_13 = QtWidgets.QGridLayout(self.layoutWidget_5)
        self.gridLayout_13.setContentsMargins(0, 0, 0, 0)
        self.gridLayout_13.setObjectName("gridLayout_13")
        self.BottomLineEdit = QtWidgets.QLineEdit(self.layoutWidget_5)
        self.BottomLineEdit.setMinimumSize(QtCore.QSize(100, 0))
        self.BottomLineEdit.setMaximumSize(QtCore.QSize(100, 16777215))
        self.BottomLineEdit.setLayoutDirection(QtCore.Qt.LeftToRight)
        self.BottomLineEdit.setAutoFillBackground(False)
        self.BottomLineEdit.setText("")
        self.BottomLineEdit.setClearButtonEnabled(True)
        self.BottomLineEdit.setObjectName("BottomLineEdit")
        self.gridLayout_13.addWidget(self.BottomLineEdit, 0, 1, 1, 1)
        self.BottomLabel = QtWidgets.QLabel(self.layoutWidget_5)
        self.BottomLabel.setMinimumSize(QtCore.QSize(100, 0))
        self.BottomLabel.setMaximumSize(QtCore.QSize(155, 16777215))
        self.BottomLabel.setLayoutDirection(QtCore.Qt.LeftToRight)
        self.BottomLabel.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.BottomLabel.setObjectName("BottomLabel")
        self.gridLayout_13.addWidget(self.BottomLabel, 0, 0, 1, 1)
        self.layoutWidget_6 = QtWidgets.QWidget(self.InputFrame)
        self.layoutWidget_6.setGeometry(QtCore.QRect(90, 340, 241, 53))
        self.layoutWidget_6.setObjectName("layoutWidget_6")
        self.gridLayout_11 = QtWidgets.QGridLayout(self.layoutWidget_6)
        self.gridLayout_11.setContentsMargins(0, 0, 0, 0)
        self.gridLayout_11.setObjectName("gridLayout_11")
        self.PSDRLabel = QtWidgets.QLabel(self.layoutWidget_6)
        self.PSDRLabel.setMinimumSize(QtCore.QSize(100, 0))
        self.PSDRLabel.setMaximumSize(QtCore.QSize(150, 16777215))
        self.PSDRLabel.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.PSDRLabel.setObjectName("PSDRLabel")
        self.gridLayout_11.addWidget(self.PSDRLabel, 0, 0, 1, 1)
        self.PSDRLineEdit = QtWidgets.QLineEdit(self.layoutWidget_6)
        self.PSDRLineEdit.setMinimumSize(QtCore.QSize(100, 0))
        self.PSDRLineEdit.setMaximumSize(QtCore.QSize(100, 16777215))
        self.PSDRLineEdit.setLayoutDirection(QtCore.Qt.LeftToRight)
        self.PSDRLineEdit.setAutoFillBackground(False)
        self.PSDRLineEdit.setText("")
        self.PSDRLineEdit.setMaxLength(32763)
        self.PSDRLineEdit.setFrame(True)
        self.PSDRLineEdit.setEchoMode(QtWidgets.QLineEdit.Normal)
        self.PSDRLineEdit.setDragEnabled(False)
        self.PSDRLineEdit.setClearButtonEnabled(True)
        self.PSDRLineEdit.setObjectName("PSDRLineEdit")
        self.gridLayout_11.addWidget(self.PSDRLineEdit, 0, 1, 1, 1)
        self.PSDRLabel2 = QtWidgets.QLabel(self.layoutWidget_6)
        self.PSDRLabel2.setMinimumSize(QtCore.QSize(100, 0))
        self.PSDRLabel2.setMaximumSize(QtCore.QSize(150, 16777215))
        self.PSDRLabel2.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.PSDRLabel2.setObjectName("PSDRLabel2")
        self.gridLayout_11.addWidget(self.PSDRLabel2, 1, 0, 1, 1)
        self.PSDRLineEdit2 = QtWidgets.QLineEdit(self.layoutWidget_6)
        self.PSDRLineEdit2.setMinimumSize(QtCore.QSize(100, 0))
        self.PSDRLineEdit2.setMaximumSize(QtCore.QSize(100, 16777215))
        self.PSDRLineEdit2.setLayoutDirection(QtCore.Qt.LeftToRight)
        self.PSDRLineEdit2.setAutoFillBackground(False)
        self.PSDRLineEdit2.setText("")
        self.PSDRLineEdit2.setMaxLength(32763)
        self.PSDRLineEdit2.setFrame(True)
        self.PSDRLineEdit2.setEchoMode(QtWidgets.QLineEdit.Normal)
        self.PSDRLineEdit2.setDragEnabled(False)
        self.PSDRLineEdit2.setClearButtonEnabled(True)
        self.PSDRLineEdit2.setObjectName("PSDRLineEdit2")
        self.gridLayout_11.addWidget(self.PSDRLineEdit2, 1, 1, 1, 1)
        self.widget = QtWidgets.QWidget(self.InputFrame)
        self.widget.setGeometry(QtCore.QRect(620, 280, 246, 53))
        self.widget.setObjectName("widget")
        self.gridLayout_7 = QtWidgets.QGridLayout(self.widget)
        self.gridLayout_7.setContentsMargins(0, 0, 0, 0)
        self.gridLayout_7.setObjectName("gridLayout_7")
        self.HightCementLabel = QtWidgets.QLabel(self.widget)
        self.HightCementLabel.setMinimumSize(QtCore.QSize(100, 0))
        self.HightCementLabel.setMaximumSize(QtCore.QSize(150, 16777215))
        self.HightCementLabel.setLayoutDirection(QtCore.Qt.LeftToRight)
        self.HightCementLabel.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.HightCementLabel.setObjectName("HightCementLabel")
        self.gridLayout_7.addWidget(self.HightCementLabel, 0, 0, 1, 1)
        self.HightCementLineEdit = QtWidgets.QLineEdit(self.widget)
        self.HightCementLineEdit.setMinimumSize(QtCore.QSize(100, 0))
        self.HightCementLineEdit.setMaximumSize(QtCore.QSize(100, 16777215))
        self.HightCementLineEdit.setLayoutDirection(QtCore.Qt.LeftToRight)
        self.HightCementLineEdit.setAutoFillBackground(False)
        self.HightCementLineEdit.setText("")
        self.HightCementLineEdit.setClearButtonEnabled(True)
        self.HightCementLineEdit.setObjectName("HightCementLineEdit")
        self.gridLayout_7.addWidget(self.HightCementLineEdit, 0, 1, 1, 1)
        self.TOCLabel = QtWidgets.QLabel(self.widget)
        self.TOCLabel.setMinimumSize(QtCore.QSize(100, 0))
        self.TOCLabel.setMaximumSize(QtCore.QSize(150, 16777215))
        self.TOCLabel.setLayoutDirection(QtCore.Qt.LeftToRight)
        self.TOCLabel.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.TOCLabel.setObjectName("TOCLabel")
        self.gridLayout_7.addWidget(self.TOCLabel, 1, 0, 1, 1)
        self.TOCLineEdit = QtWidgets.QLineEdit(self.widget)
        self.TOCLineEdit.setMinimumSize(QtCore.QSize(100, 0))
        self.TOCLineEdit.setMaximumSize(QtCore.QSize(100, 16777215))
        self.TOCLineEdit.setLayoutDirection(QtCore.Qt.LeftToRight)
        self.TOCLineEdit.setAutoFillBackground(False)
        self.TOCLineEdit.setText("")
        self.TOCLineEdit.setClearButtonEnabled(True)
        self.TOCLineEdit.setObjectName("TOCLineEdit")
        self.gridLayout_7.addWidget(self.TOCLineEdit, 1, 1, 1, 1)
        self.gridLayout_8.addWidget(self.InputFrame, 0, 0, 1, 1)
        self.CPTab.addTab(self.CP2Tab, "")
        self.CP4Tab = QtWidgets.QWidget()
        self.CP4Tab.setObjectName("CP4Tab")
        self.gridLayout_5 = QtWidgets.QGridLayout(self.CP4Tab)
        self.gridLayout_5.setObjectName("gridLayout_5")
        self.GeneralFrame = QtWidgets.QFrame(self.CP4Tab)
        self.GeneralFrame.setMaximumSize(QtCore.QSize(16777215, 16777215))
        self.GeneralFrame.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.GeneralFrame.setFrameShadow(QtWidgets.QFrame.Raised)
        self.GeneralFrame.setObjectName("GeneralFrame")
        self.gridLayout_6 = QtWidgets.QGridLayout(self.GeneralFrame)
        self.gridLayout_6.setObjectName("gridLayout_6")
        self.TubeIDLineEdit = QtWidgets.QLineEdit(self.GeneralFrame)
        self.TubeIDLineEdit.setMaximumSize(QtCore.QSize(100, 16777215))
        self.TubeIDLineEdit.setText("")
        self.TubeIDLineEdit.setClearButtonEnabled(True)
        self.TubeIDLineEdit.setObjectName("TubeIDLineEdit")
        self.gridLayout_6.addWidget(self.TubeIDLineEdit, 0, 1, 1, 1)
        self.HoleSizeLineEdit = QtWidgets.QLineEdit(self.GeneralFrame)
        self.HoleSizeLineEdit.setMaximumSize(QtCore.QSize(100, 16777215))
        self.HoleSizeLineEdit.setText("")
        self.HoleSizeLineEdit.setClearButtonEnabled(True)
        self.HoleSizeLineEdit.setObjectName("HoleSizeLineEdit")
        self.gridLayout_6.addWidget(self.HoleSizeLineEdit, 0, 3, 1, 1)
        self.TubeODLabel = QtWidgets.QLabel(self.GeneralFrame)
        self.TubeODLabel.setMinimumSize(QtCore.QSize(100, 0))
        self.TubeODLabel.setMaximumSize(QtCore.QSize(150, 16777215))
        self.TubeODLabel.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.TubeODLabel.setObjectName("TubeODLabel")
        self.gridLayout_6.addWidget(self.TubeODLabel, 3, 0, 1, 1)
        self.TubeODLineEdit = QtWidgets.QLineEdit(self.GeneralFrame)
        self.TubeODLineEdit.setMaximumSize(QtCore.QSize(100, 16777215))
        self.TubeODLineEdit.setText("")
        self.TubeODLineEdit.setClearButtonEnabled(True)
        self.TubeODLineEdit.setObjectName("TubeODLineEdit")
        self.gridLayout_6.addWidget(self.TubeODLineEdit, 3, 1, 1, 1)
        self.ExcessLabel = QtWidgets.QLabel(self.GeneralFrame)
        self.ExcessLabel.setMinimumSize(QtCore.QSize(100, 0))
        self.ExcessLabel.setMaximumSize(QtCore.QSize(150, 16777215))
        self.ExcessLabel.setLayoutDirection(QtCore.Qt.LeftToRight)
        self.ExcessLabel.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.ExcessLabel.setObjectName("ExcessLabel")
        self.gridLayout_6.addWidget(self.ExcessLabel, 5, 2, 1, 1)
        self.TubeIDLabel = QtWidgets.QLabel(self.GeneralFrame)
        self.TubeIDLabel.setMinimumSize(QtCore.QSize(100, 0))
        self.TubeIDLabel.setMaximumSize(QtCore.QSize(150, 16777215))
        self.TubeIDLabel.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.TubeIDLabel.setObjectName("TubeIDLabel")
        self.gridLayout_6.addWidget(self.TubeIDLabel, 0, 0, 1, 1)
        self.HoleSizeLabel = QtWidgets.QLabel(self.GeneralFrame)
        self.HoleSizeLabel.setMinimumSize(QtCore.QSize(100, 0))
        self.HoleSizeLabel.setMaximumSize(QtCore.QSize(150, 16777215))
        self.HoleSizeLabel.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.HoleSizeLabel.setObjectName("HoleSizeLabel")
        self.gridLayout_6.addWidget(self.HoleSizeLabel, 0, 2, 1, 1)
        self.PipeIDLabel = QtWidgets.QLabel(self.GeneralFrame)
        self.PipeIDLabel.setMinimumSize(QtCore.QSize(100, 0))
        self.PipeIDLabel.setMaximumSize(QtCore.QSize(150, 16777215))
        self.PipeIDLabel.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.PipeIDLabel.setObjectName("PipeIDLabel")
        self.gridLayout_6.addWidget(self.PipeIDLabel, 4, 0, 1, 1)
        self.PipeIDLineEdit = QtWidgets.QLineEdit(self.GeneralFrame)
        self.PipeIDLineEdit.setMaximumSize(QtCore.QSize(100, 16777215))
        self.PipeIDLineEdit.setText("")
        self.PipeIDLineEdit.setClearButtonEnabled(True)
        self.PipeIDLineEdit.setObjectName("PipeIDLineEdit")
        self.gridLayout_6.addWidget(self.PipeIDLineEdit, 4, 1, 1, 1)
        self.CementDensLineEdit = QtWidgets.QLineEdit(self.GeneralFrame)
        self.CementDensLineEdit.setMaximumSize(QtCore.QSize(100, 16777215))
        self.CementDensLineEdit.setText("")
        self.CementDensLineEdit.setClearButtonEnabled(True)
        self.CementDensLineEdit.setObjectName("CementDensLineEdit")
        self.gridLayout_6.addWidget(self.CementDensLineEdit, 4, 3, 1, 1)
        self.PipeODLineEdit = QtWidgets.QLineEdit(self.GeneralFrame)
        self.PipeODLineEdit.setMaximumSize(QtCore.QSize(100, 16777215))
        self.PipeODLineEdit.setText("")
        self.PipeODLineEdit.setClearButtonEnabled(True)
        self.PipeODLineEdit.setObjectName("PipeODLineEdit")
        self.gridLayout_6.addWidget(self.PipeODLineEdit, 5, 1, 1, 1)
        self.PipeODLabel = QtWidgets.QLabel(self.GeneralFrame)
        self.PipeODLabel.setMinimumSize(QtCore.QSize(100, 0))
        self.PipeODLabel.setMaximumSize(QtCore.QSize(150, 16777215))
        self.PipeODLabel.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.PipeODLabel.setObjectName("PipeODLabel")
        self.gridLayout_6.addWidget(self.PipeODLabel, 5, 0, 1, 1)
        self.CementDensLabel = QtWidgets.QLabel(self.GeneralFrame)
        self.CementDensLabel.setMinimumSize(QtCore.QSize(100, 0))
        self.CementDensLabel.setMaximumSize(QtCore.QSize(150, 16777215))
        self.CementDensLabel.setLayoutDirection(QtCore.Qt.LeftToRight)
        self.CementDensLabel.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.CementDensLabel.setObjectName("CementDensLabel")
        self.gridLayout_6.addWidget(self.CementDensLabel, 4, 2, 1, 1)
        self.ExcessLineEdit = QtWidgets.QLineEdit(self.GeneralFrame)
        self.ExcessLineEdit.setMaximumSize(QtCore.QSize(100, 16777215))
        self.ExcessLineEdit.setText("")
        self.ExcessLineEdit.setClearButtonEnabled(True)
        self.ExcessLineEdit.setObjectName("ExcessLineEdit")
        self.gridLayout_6.addWidget(self.ExcessLineEdit, 5, 3, 1, 1)
        self.CementLengthLabel = QtWidgets.QLabel(self.GeneralFrame)
        self.CementLengthLabel.setMinimumSize(QtCore.QSize(100, 0))
        self.CementLengthLabel.setMaximumSize(QtCore.QSize(150, 16777215))
        self.CementLengthLabel.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.CementLengthLabel.setObjectName("CementLengthLabel")
        self.gridLayout_6.addWidget(self.CementLengthLabel, 3, 2, 1, 1)
        self.CementLengthLineEdit = QtWidgets.QLineEdit(self.GeneralFrame)
        self.CementLengthLineEdit.setMaximumSize(QtCore.QSize(100, 16777215))
        self.CementLengthLineEdit.setText("")
        self.CementLengthLineEdit.setClearButtonEnabled(True)
        self.CementLengthLineEdit.setObjectName("CementLengthLineEdit")
        self.gridLayout_6.addWidget(self.CementLengthLineEdit, 3, 3, 1, 1)
        self.gridLayout_5.addWidget(self.GeneralFrame, 0, 0, 1, 1)
        self.CPTab.addTab(self.CP4Tab, "")
        self.CP3Tab = QtWidgets.QWidget()
        self.CP3Tab.setObjectName("CP3Tab")
        self.SDFrame = QtWidgets.QFrame(self.CP3Tab)
        self.SDFrame.setGeometry(QtCore.QRect(10, 0, 981, 541))
        self.SDFrame.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.SDFrame.setFrameShadow(QtWidgets.QFrame.Raised)
        self.SDFrame.setObjectName("SDFrame")
        self.SpacerDensLabel = QtWidgets.QLabel(self.SDFrame)
        self.SpacerDensLabel.setGeometry(QtCore.QRect(362, 268, 150, 16))
        self.SpacerDensLabel.setMinimumSize(QtCore.QSize(150, 0))
        self.SpacerDensLabel.setMaximumSize(QtCore.QSize(150, 16777215))
        self.SpacerDensLabel.setLayoutDirection(QtCore.Qt.LeftToRight)
        self.SpacerDensLabel.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.SpacerDensLabel.setObjectName("SpacerDensLabel")
        self.SpacerDensLineEdit = QtWidgets.QLineEdit(self.SDFrame)
        self.SpacerDensLineEdit.setGeometry(QtCore.QRect(519, 268, 100, 22))
        self.SpacerDensLineEdit.setMaximumSize(QtCore.QSize(100, 16777215))
        self.SpacerDensLineEdit.setText("")
        self.SpacerDensLineEdit.setClearButtonEnabled(True)
        self.SpacerDensLineEdit.setObjectName("SpacerDensLineEdit")
        self.SpacerVLineEdit = QtWidgets.QLineEdit(self.SDFrame)
        self.SpacerVLineEdit.setGeometry(QtCore.QRect(519, 180, 100, 22))
        self.SpacerVLineEdit.setMaximumSize(QtCore.QSize(100, 16777215))
        self.SpacerVLineEdit.setText("")
        self.SpacerVLineEdit.setClearButtonEnabled(True)
        self.SpacerVLineEdit.setObjectName("SpacerVLineEdit")
        self.SpacerVLabel = QtWidgets.QLabel(self.SDFrame)
        self.SpacerVLabel.setGeometry(QtCore.QRect(362, 180, 150, 16))
        self.SpacerVLabel.setMinimumSize(QtCore.QSize(150, 0))
        self.SpacerVLabel.setMaximumSize(QtCore.QSize(150, 16777215))
        self.SpacerVLabel.setLayoutDirection(QtCore.Qt.LeftToRight)
        self.SpacerVLabel.setAlignment(QtCore.Qt.AlignLeading|QtCore.Qt.AlignLeft|QtCore.Qt.AlignVCenter)
        self.SpacerVLabel.setObjectName("SpacerVLabel")
        self.CPTab.addTab(self.CP3Tab, "")
        self.CP5Tab = QtWidgets.QWidget()
        self.CP5Tab.setObjectName("CP5Tab")
        self.DFFrame = QtWidgets.QFrame(self.CP5Tab)
        self.DFFrame.setGeometry(QtCore.QRect(10, 0, 971, 501))
        self.DFFrame.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.DFFrame.setFrameShadow(QtWidgets.QFrame.Raised)
        self.DFFrame.setObjectName("DFFrame")
        self.MudTypeLabel = QtWidgets.QLabel(self.DFFrame)
        self.MudTypeLabel.setGeometry(QtCore.QRect(362, 180, 150, 16))
        self.MudTypeLabel.setMinimumSize(QtCore.QSize(150, 0))
        self.MudTypeLabel.setMaximumSize(QtCore.QSize(150, 16777215))
        self.MudTypeLabel.setObjectName("MudTypeLabel")
        self.MudDensLabel = QtWidgets.QLabel(self.DFFrame)
        self.MudDensLabel.setGeometry(QtCore.QRect(362, 268, 150, 16))
        self.MudDensLabel.setMinimumSize(QtCore.QSize(150, 0))
        self.MudDensLabel.setMaximumSize(QtCore.QSize(150, 16777215))
        self.MudDensLabel.setObjectName("MudDensLabel")
        self.MudTypeComboBox = QtWidgets.QComboBox(self.DFFrame)
        self.MudTypeComboBox.setGeometry(QtCore.QRect(519, 180, 100, 22))
        self.MudTypeComboBox.setMaximumSize(QtCore.QSize(100, 16777215))
        self.MudTypeComboBox.setEditable(True)
        self.MudTypeComboBox.setObjectName("MudTypeComboBox")
        self.MudTypeComboBox.addItem("")
        self.MudTypeComboBox.addItem("")
        self.MudTypeComboBox.addItem("")
        self.MudDensLineEdit = QtWidgets.QLineEdit(self.DFFrame)
        self.MudDensLineEdit.setGeometry(QtCore.QRect(519, 268, 100, 22))
        self.MudDensLineEdit.setMaximumSize(QtCore.QSize(100, 16777215))
        self.MudDensLineEdit.setObjectName("MudDensLineEdit")
        #self.gridLayout_7.addWidget(self.MudTypeComboBox, 1, 1, 1, 1)
        #spacerItem8 = QtWidgets.QSpacerItem(40, 20, QtWidgets.QSizePolicy.Expanding, QtWidgets.QSizePolicy.Minimum)
        #self.gridLayout_7.addItem(spacerItem8, 1, 3, 1, 1)
        self.CalcButton = QtWidgets.QPushButton(self.CP5Tab)
        self.CalcButton.setGeometry(QtCore.QRect(400, 460, 200, 28))
        self.CalcButton.setMinimumSize(QtCore.QSize(150, 0))
        self.CalcButton.setMaximumSize(QtCore.QSize(250, 16777215))
        self.CalcButton.setCheckable(False)
        self.CalcButton.setObjectName("CalcButton")
        self.CPTab.addTab(self.CP5Tab, "")
        self.tabWidget.addTab(self.tab_2, "")
        self.tab_4 = QtWidgets.QWidget()
        self.tab_4.setObjectName("tab_4")
        self.ContractsTab = QtWidgets.QTabWidget(self.tab_4)
        self.ContractsTab.setGeometry(QtCore.QRect(0, 0, 991, 571))
        self.ContractsTab.setTabPosition(QtWidgets.QTabWidget.North)
        self.ContractsTab.setObjectName("ContractsTab")
        self.tab_5 = QtWidgets.QWidget()
        self.tab_5.setObjectName("tab_5")
        self.CasingRunningLabel = QtWidgets.QLabel(self.tab_5)
        self.CasingRunningLabel.setGeometry(QtCore.QRect(0, 0, 981, 541))
        self.CasingRunningLabel.setScaledContents(True)
        self.CasingRunningLabel.setWordWrap(True)
        self.CasingRunningLabel.setObjectName("CasingRunningLabel")
        self.ContractsTab.addTab(self.tab_5, "")
        self.tab_6 = QtWidgets.QWidget()
        self.tab_6.setObjectName("tab_6")
        self.CemServLabel = QtWidgets.QLabel(self.tab_6)
        self.CemServLabel.setGeometry(QtCore.QRect(0, 0, 971, 531))
        self.CemServLabel.setScaledContents(True)
        self.CemServLabel.setWordWrap(True)
        self.CemServLabel.setObjectName("CemServLabel")
        self.ContractsTab.addTab(self.tab_6, "")
        self.tab_7 = QtWidgets.QWidget()
        self.tab_7.setObjectName("tab_7")
        self.CTLabel = QtWidgets.QLabel(self.tab_7)
        self.CTLabel.setGeometry(QtCore.QRect(0, 0, 971, 531))
        self.CTLabel.setScaledContents(True)
        self.CTLabel.setWordWrap(True)
        self.CTLabel.setOpenExternalLinks(False)
        self.CTLabel.setObjectName("CTLabel")
        self.ContractsTab.addTab(self.tab_7, "")
        self.tab_8 = QtWidgets.QWidget()
        self.tab_8.setObjectName("tab_8")
        self.EnvLabel = QtWidgets.QLabel(self.tab_8)
        self.EnvLabel.setGeometry(QtCore.QRect(0, 0, 971, 531))
        self.EnvLabel.setScaledContents(True)
        self.EnvLabel.setWordWrap(True)
        self.EnvLabel.setObjectName("EnvLabel")
        self.ContractsTab.addTab(self.tab_8, "")
        self.tab_9 = QtWidgets.QWidget()
        self.tab_9.setObjectName("tab_9")
        self.MLLabel = QtWidgets.QLabel(self.tab_9)
        self.MLLabel.setGeometry(QtCore.QRect(0, 0, 971, 531))
        self.MLLabel.setScaledContents(True)
        self.MLLabel.setWordWrap(True)
        self.MLLabel.setObjectName("MLLabel")
        self.ContractsTab.addTab(self.tab_9, "")
        self.tab_10 = QtWidgets.QWidget()
        self.tab_10.setObjectName("tab_10")
        self.RigLabel = QtWidgets.QLabel(self.tab_10)
        self.RigLabel.setGeometry(QtCore.QRect(0, 0, 971, 531))
        self.RigLabel.setScaledContents(True)
        self.RigLabel.setWordWrap(True)
        self.RigLabel.setObjectName("RigLabel")
        self.ContractsTab.addTab(self.tab_10, "")
        self.tab_11 = QtWidgets.QWidget()
        self.tab_11.setObjectName("tab_11")
        self.WellTLabel = QtWidgets.QLabel(self.tab_11)
        self.WellTLabel.setGeometry(QtCore.QRect(0, 0, 971, 531))
        self.WellTLabel.setScaledContents(True)
        self.WellTLabel.setWordWrap(True)
        self.WellTLabel.setObjectName("WellTLabel")
        self.ContractsTab.addTab(self.tab_11, "")
        self.tab_12 = QtWidgets.QWidget()
        self.tab_12.setObjectName("tab_12")
        self.WHLabel = QtWidgets.QLabel(self.tab_12)
        self.WHLabel.setGeometry(QtCore.QRect(0, 0, 971, 531))
        self.WHLabel.setScaledContents(True)
        self.WHLabel.setWordWrap(True)
        self.WHLabel.setObjectName("WHLabel")
        self.ContractsTab.addTab(self.tab_12, "")
        self.tabWidget.addTab(self.tab_4, "")
        Software.setCentralWidget(self.centralwidget)
        self.menubar = QtWidgets.QMenuBar(Software)
        self.menubar.setGeometry(QtCore.QRect(0, 0, 1000, 26))
        self.menubar.setObjectName("menubar")
        Software.setMenuBar(self.menubar)
        self.statusbar = QtWidgets.QStatusBar(Software)
        self.statusbar.setObjectName("statusbar")
        Software.setStatusBar(self.statusbar)
        self.actionSave = QtWidgets.QAction(Software)
        self.actionSave.setObjectName("actionSave")
        self.actionOpen = QtWidgets.QAction(Software)
        self.actionOpen.setObjectName("actionOpen")
        self.actionHome = QtWidgets.QAction(Software)
        icon = QtGui.QIcon()
        icon.addPixmap(QtGui.QPixmap("C:/Users/AMIN/OneDrive/Pictures/884555.jpeg"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
        self.actionHome.setIcon(icon)
        self.actionHome.setObjectName("actionHome")
        
        self.CalcButton.clicked.connect(self.calculate)

        self.retranslateUi(Software)
        self.tabWidget.setCurrentIndex(0)
        QtCore.QMetaObject.connectSlotsByName(Software)
        
        self.grab_all()

    def grab_all(self):
        
        conn = sqlite3.connect('mylist.db')

        c = conn.cursor()
        
        c.execute("Select * FROM well_list")
        records = c.fetchall()
        

        
        
        for record in records:
            self.mylist_listWidget.addItem(str(record[0]))
            
    def clicker(self,index):
        
        #Clear the second box
        self.EventBox.clear()
        #Dependent
        self.EventBox.addItems(self.ObjectiveBox.itemData(index))            
            
            
    def save_it(self):
            
            conn = sqlite3.connect('mylist.db')

            c = conn.cursor()
            
            c.execute('DELETE FROM well_list;',)
            
            items = [self.Nameline,self.Typeline,self.Resline,self.Objtext,self.Sumtext]
            
            for item in items:
                c.execute("INSERT INTO well_list VALUES (:item)",
                {
                    'item': item.Info(),
                })
                                       
            conn.commit()

            conn.close()
            
            msg = QMessageBox()
            msg.setWindowTitle("Well Information saved!")
            msg.setText("The infoprmation has been saved in database.")
            msg.setIcon(QMessageBox.Information)
            # x = msg.exec_()
            
    def calculate(self):
        
        csg = float(self.CSLineEdit.text())
        csgs_MD = float(self.CasingShoeMDLineEdit.text())
        csgs_TVD = float(self.CasingShoeTVDEditLine.text())
        Hole_Size = float(self.HoleSizeLineEdit.text())
        HD_MD = float(self.HDMDLineEdit.text())
        HD_TVD = float(self.HDTVDLineEdit.text())
        PSDR = float(self.PSDRLineEdit.text())
        Tubing = float(self.TubeODLineEdit.text())
        Tubing_ID = float(self.TubeIDLineEdit.text())
        DP_OD = float(self.PipeODLineEdit.text())
        DP_ID = float(self.PipeIDLineEdit.text())
        V_s = float(self.SpacerVLineEdit.text())
        Spacer_Den = float(self.SpacerDensLineEdit.text())
        PLC = float(self.CementLengthLineEdit.text())
        PBCP = float(self.BottomLineEdit.text())
        TOC = float(self.TOCLineEdit.text())
        HCS = float(self.HightCementLineEdit.text())
        Cement_DEN = float(self.CementDensLineEdit.text())
        EX = float(self.ExcessLineEdit.text())
        Mud_dens = float(self.MudDensLineEdit.text())
        
        #Equations
        Hole_Cap = Hole_Size**2 / 1029.4
        CSC = Tubing_ID**2 / 1029.4
        ACCS = (Hole_Size**2 - Tubing**2) / 1029.4
        ACDP = (Hole_Size**2 - DP_OD**2 )/ 1029.4
        DP_CAP = DP_ID**2 / 1029.4
        
        #Cement: 
        VC = PLC * Hole_Cap * (1+0.01*EX)
        HC_s = VC / (CSC + ACCS)  
        TOC_p = PBCP - HC_s
        
        #Spacer:
        HS_s = ACCS * (TOC_p - TOC)
        RS_dp_h = V_s - HS_s
        LC_dp_h = RS_dp_h / ACDP
        TOS = TOC - LC_dp_h
        VS_s = CSC * (TOC_p - TOC)
        VS_dp = DP_CAP * (TOC - TOS)
        TSV_s = VS_dp + VS_s
    
        #Mud Displacement:
        V_md = TOS * DP_CAP
        
        output_values = OrderedDict({
             "Capacities": "",
             "Hole Capacity [bbl/ft]":  round(Hole_Cap,4),
             "Cement stringer capacity [bbl/ft]": round(CSC,4),
             "Annular capacity b/w hole & cement stinger [bbl/ft]": round(ACCS,4),
             "Annular capacity b/w hole & drill pipe [bbl/ft]": round(ACDP,4),
             "Drill pipe capacity [bbl/ft]": round(DP_CAP,4),
             "Cement": "",
             "Volume of cement [bbl]": round(VC,4),
             "Height of cement while cement string in well [ft]": round(HC_s,4),
             "TOC (when pipe is in hole [ft])": round(TOC_p,4),
             "Spacer": "",
             "Height of spacer while cement string in well [bbl]": round(HS_s,4),
             "Rest of spacer b/w drill pipe and hole [bbl]": round(RS_dp_h,4),
             "Length of spacer b/w drill pipe & hole [ft]": round(LC_dp_h,4),
             "Top of spacer [ft]": round(TOS,4),
             "Volume of spacer in cement stinger [bbl]": round(VS_s,4),
             "Volume of spacer in drill pipe [bbl]": round(VS_dp,4),
             "Total spacer volume in string [bbl]": round(TSV_s,4),
             "Mud Displacement": "",
             "Volume of mud displacement [bbl]": round(V_md,4),
             "":"",
             "":"",
             "":"",
             "Pumping Schedule": "",
             "1. Pump Spacer [bbl]": round(V_s,4),
             "2. Pump Cement [bbl]": round(VC,4),
             "3. Pump Spacer [bbl]": round(TSV_s,4),
             "4. Pump Drilling Mud [bbl]": round(V_md,4),
             "5. Pull slowly above TOC": "",
             "6. Circulate bottom up": "",
             "7. Pull out of hole to surface": ""
         })

        for key, value in output_values.items():
            if value == "":
                print(key)
            else:
                print(key, value)
        
        
        self.output_window = OutputWindow(output_values)
        self.output_window.show()

    def retranslateUi(self, Software):
        _translate = QtCore.QCoreApplication.translate
        Software.setWindowTitle(_translate("Software", "PlugDgitize"))
        self.SaveButton.setText(_translate("Software", "Save Data"))
        self.label.setText(_translate("Software", "Well"))
        self.Nameline.setPlaceholderText(_translate("Software", "Name"))
        self.Typeline.setPlaceholderText(_translate("Software", "Type"))
        self.Resline.setPlaceholderText(_translate("Software", "Reservoir"))
        self.label_2.setText(_translate("Software", "Objective/Scope\n"""))
        self.Sumtext.setPlaceholderText(_translate("Software", "Write here..."))
        self.label_3.setText(_translate("Software", "Summary of planned events \n"""))
        self.Objtext.setPlaceholderText(_translate("Software", "Write here..."))
        self.tabWidget.setTabText(self.tabWidget.indexOf(self.tab_3), _translate("Software", "Well Information"))
        self.DisciplineLabel.setText(_translate("Software", "Discipline"))
        self.EventLabel.setText(_translate("Software", "Event"))
        self.ObjectiveLabel.setText(_translate("Software", "Objective"))
        self.SectionLabel.setText(_translate("Software", "Section"))
        self.label_9.setText(_translate("Software", "Contracts"))
        self.label_7.setText(_translate("Software", "Engineering"))
        self.tabWidget.setTabText(self.tabWidget.indexOf(self.tab), _translate("Software", "Main Window"))
        self.Info_Label.setText(_translate("Software", "<html><head/><body><p align=\"justify\"><span style=\" font-size:10pt; font-weight:600;\">Welcome to the Cement Plugging Software!</span></p><p align=\"justify\"><span style=\" font-weight:600;\">Overview:</span></p><p align=\"justify\">The Cement Plugging Software is a cutting-edge tool designed specifically for optimizing cement plugging using the Balanced Plug method within plug and abandonment (P&amp;A) operations. By leveraging digitalization and advanced algorithms, this software enhances efficiency, accuracy, and decision-making, ensuring superior zonal isolation and wellbore integrity.</p><p align=\"justify\"><span style=\" font-weight:600;\">Purpose:</span></p><p align=\"justify\">The software is tailored to provide a comprehensive and user-friendly environment for optimizing cement plugging techniques using the Balanced Plug method. It focuses specifically on cementing strategies utilizing oil-based mud. By adhering to this specific method and mud type, the software offers precise calculations that align with industry standards and best practices.</p><p align=\"justify\"><span style=\" font-weight:600;\">Calculations:</span></p><p align=\"justify\">When utilizing the software, users input relevant wellbore parameters specific to the Balanced Plug method and oil-based mud. The software performs intricate calculations based on these inputs to determine the optimal volumes of cement required. By incorporating equations from the &quot;drilling-info&quot; website, the software ensures accurate estimation of cement volumes, taking into account factors such as casing size, casing shoe depths (MD and TVD), hole size, hole depths (MD and TVD), pay sand depth range, tubing, tubing ID, drill pipe OD, and drill pipe ID. Through these calculations, the software enables users to achieve precise and effective cement placement, supporting superior zonal isolation and wellbore integrity.</p><p align=\"justify\">By utilizing the Cement Plugging Software, users can optimize cement plugging using the Balanced Plug method with oil-based mud. This software empowers users to make informed decisions, enhance efficiency, and ensure superior zonal isolation and wellbore integrity within plug and abandonment operations.</p></body></html>"))
        self.CPTab.setTabText(self.CPTab.indexOf(self.CP1Tab), _translate("Software", "Information"))
        self.HDMDLineEdit.setPlaceholderText(_translate("Software", "[feet]"))
        self.PSDRLineEdit.setPlaceholderText(_translate("Software", "[feet]"))
        self.PSDRLabel2.setText(_translate("Software", "Pay Sand Bottom Depth"))
        self.PSDRLabel2.setAccessibleName(_translate("Software", "[feet]"))
        self.PSDRLineEdit2.setPlaceholderText(_translate("Software", "[feet]"))
        self.CasingShoeMDLabel.setText(_translate("Software", "Casing Shoe Depth (MD)"))
        self.TubeODLineEdit.setPlaceholderText(_translate("Software", "[inches]"))
        self.TubeIDLabel.setText(_translate("Software", "Drill Tube ID"))
        self.TubeIDLineEdit.setPlaceholderText(_translate("Software", "[inches]"))
        self.CasingShoeMDLineEdit.setPlaceholderText(_translate("Software", "[feet]"))
        self.TubeODLabel.setText(_translate("Software", "Drill Tube OD"))
        self.PipeIDLabel.setText(_translate("Software", "Drill Pipe ID"))
        self.CasingSizeLabel.setText(_translate("Software", "Casing Size"))
        self.PipeIDLineEdit.setPlaceholderText(_translate("Software", "[inches]"))
        self.PipeODLabel.setText(_translate("Software", "Drill Pipe OD"))
        self.PipeODLineEdit.setPlaceholderText(_translate("Software", "[inches]"))
        self.HoleDepthMDLabel.setText(_translate("Software", "Hole Depth (MD)"))
        self.HDTVDLineEdit.setPlaceholderText(_translate("Software", "[feet]"))
        self.CSLineEdit.setPlaceholderText(_translate("Software", "[inches]"))
        self.CasingShoeTVDLabel.setText(_translate("Software", "Casing Shoe Depth (TVD)"))
        self.HoleSizeLabel.setText(_translate("Software", "Hole Size"))
        self.CasingShoeTVDEditLine.setPlaceholderText(_translate("Software", "[feet]"))
        self.HoleSizeLineEdit.setPlaceholderText(_translate("Software", "[inches]"))
        self.HoleDepthTVDLabel.setText(_translate("Software", "Hole Depth (TVD)"))
        self.PSDRLabel.setText(_translate("Software", "Pay Sand Top Depth"))
        self.CPTab.setTabText(self.CPTab.indexOf(self.CP2Tab), _translate("Software", "Diagram Input"))
        self.SpacerDensLabel.setText(_translate("Software", "Density of Spacer"))
        self.SpacerDensLineEdit.setPlaceholderText(_translate("Software", "[ppg]"))
        self.SpacerVLineEdit.setPlaceholderText(_translate("Software", "[bbl]"))
        self.SpacerVLabel.setText(_translate("Software", "Volume of Spacer"))
        self.CPTab.setTabText(self.CPTab.indexOf(self.CP3Tab), _translate("Software", "Spacer Design"))
        self.CementDensLineEdit.setPlaceholderText(_translate("Software", "[ppg]"))
        self.CementDensLabel.setText(_translate("Software", "Required Cement Density"))
        self.ExcessLineEdit.setPlaceholderText(_translate("Software", "[%]"))
        self.HightCementLabel.setText(_translate("Software", "Hight of Cement Stinger"))
        self.CementLengthLineEdit.setPlaceholderText(_translate("Software", "[feet]"))
        self.TOCLabel.setText(_translate("Software", "TOC with Stinger"))
        self.CementLengthLabel.setText(_translate("Software", "Planned Cement Length"))
        self.TOCLineEdit.setPlaceholderText(_translate("Software", "[feet]"))
        self.ExcessLabel.setText(_translate("Software", "Excess"))
        self.BottomLineEdit.setPlaceholderText(_translate("Software", "[feet]"))
        self.HightCementLineEdit.setPlaceholderText(_translate("Software", "[feet]"))
        self.BottomLabel.setText(_translate("Software", "Planned Bottom of Cement Plug"))
        self.CPTab.setTabText(self.CPTab.indexOf(self.CP4Tab), _translate("Software", "General Input"))
        self.MudTypeLabel.setText(_translate("Software", "Mud Type"))
        self.MudDensLineEdit.setPlaceholderText(_translate("Software", "[ppg]"))
        self.MudDensLabel.setText(_translate("Software", "Mud Density"))
        self.MudTypeComboBox.setItemText(0, _translate("Software", "Oil Based"))
        self.MudTypeComboBox.setItemText(1, _translate("Software", "Water Based"))
        self.MudTypeComboBox.setItemText(2, _translate("Software", "Custom"))
        self.CalcButton.setText(_translate("Software", "Calculate"))
        self.CPTab.setTabText(self.CPTab.indexOf(self.CP5Tab), _translate("Software", "Drilling Fluid"))
        self.tabWidget.setTabText(self.tabWidget.indexOf(self.tab_2), _translate("Software", "Cement Plugging"))
        self.CasingRunningLabel.setText(_translate("Software", "Coming Soon..."))
        self.ContractsTab.setTabText(self.ContractsTab.indexOf(self.tab_5), _translate("Software", "Casing Running"))
        self.CemServLabel.setText(_translate("Software", "Coming Soon..."))
        self.ContractsTab.setTabText(self.ContractsTab.indexOf(self.tab_6), _translate("Software", "Cementing Services"))
        self.CTLabel.setText(_translate("Software", "Coming Soon..."))
        self.ContractsTab.setTabText(self.ContractsTab.indexOf(self.tab_7), _translate("Software", "Coiled Tubing"))
        self.EnvLabel.setText(_translate("Software", "Coming Soon..."))
        self.ContractsTab.setTabText(self.ContractsTab.indexOf(self.tab_8), _translate("Software", "Environmental and Waste Control"))
        self.MLLabel.setText(_translate("Software", "Coming Soon..."))
        self.ContractsTab.setTabText(self.ContractsTab.indexOf(self.tab_9), _translate("Software", "Mud Logging"))
        self.RigLabel.setText(_translate("Software", "Coming Soon..."))
        self.ContractsTab.setTabText(self.ContractsTab.indexOf(self.tab_10), _translate("Software", "Rig Contract"))
        self.WellTLabel.setText(_translate("Software", "Coming Soon..."))
        self.ContractsTab.setTabText(self.ContractsTab.indexOf(self.tab_11), _translate("Software", "Well Testing"))
        self.WHLabel.setText(_translate("Software", "Coming Soon..."))
        self.ContractsTab.setTabText(self.ContractsTab.indexOf(self.tab_12), _translate("Software", "WH / XT"))
        self.tabWidget.setTabText(self.tabWidget.indexOf(self.tab_4), _translate("Software", "Contracts"))
        self.actionSave.setText(_translate("Software", "Save"))
        self.actionOpen.setText(_translate("Software", "Open"))
        self.actionHome.setText(_translate("Software", "Home"))


if __name__ == "__main__":
    app = QtWidgets.QApplication(sys.argv)
    Software = QtWidgets.QMainWindow()
    ui = Ui_Software()
    ui.setupUi(Software)
    Software.show()
    sys.exit(app.exec_())
